#include "internal.h"


static unsigned long crc32table[256];
static char inited = 0;

static void initcrc32table(void)
{
	unsigned long i,j,k;
	
	// algorithm and polynomial same as that used by infozip's zip
	for (i=0; i<256; i++) {
		j = i;
		for (k=8; k; k--)
			j = (j&1) ? (0xedb88320L ^ (j>>1)) : (j>>1);
		crc32table[i] = j;
	}

	inited=1;
}

fileident hashfn(const char *fn, const char *subfn)
{
	fileident id;

	id.a.flags = 0;
	if (!inited) initcrc32table();
	
	id.a.ident = 0xffffffffl;
	while (*fn) id.a.ident = crc32table[(id.a.ident ^ *(fn++)) & 0xffl] ^ (id.a.ident >> 8);
	if (subfn) {
		id.a.ident = crc32table[(id.a.ident ^ 0) & 0xffl] ^ (id.a.ident >> 8);
		while (*subfn) id.a.ident = crc32table[(id.a.ident ^ *(subfn++)) & 0xffl] ^ (id.a.ident >> 8);
	}
	id.a.ident ^= 0xffffffffl;
	
	return id;
}


