// Pthreads implementation of the refresh thread

#include "internal.h"
#include "thread.h"
#if 0
#include <pthread.h>


static char initialised = 0, shuttingdown = 0;
static pthread_t threadh;
static pthread_mutex_t lockmutex;

static void *refreshthread(void *)
{
	initialised = 1;

	while (!shuttingdown) {
		thread_entercritical();
		thread_leavecritical();
	}

	pthread_exit(NULL);
}

jfauderr thread_startrefresh(void)
{
	pthread_mutexattr_t mattr;

	if (initialised) return jfauderr_alreadyinited;

	if (pthread_mutexattr_init(&mattr)) return jfauderr_genericerror;
	if (pthread_mutexattr_settype(&mattr, PTHREAD_MUTEX_ERRORCHECK)) {
		pthread_mutexattr_destroy(&mattr);
		return jfauderr_genericerror;
	}
	if (pthread_mutex_init(&lockmutex, &mattr)) {
		pthread_mutexattr_destroy(&mattr);
		return jfauderr_genericerror;
	}

	// create shutdown mutex and condition variable

	pthread_mutexattr_destroy(&mattr);

	shuttingdown = 0;

	if (pthread_create(&threadh, NULL, refreshthread, NULL)) {
		pthread_mutex_destroy(&lockmutex);
		return jfauderr_genericerror;
	}

	return jfauderr_noerror;
}

jfauderr thread_stoprefresh(void)
{
	if (!initialised) return jfauderr_notinited;

	// lock a shutdown mutex
	shuttingdown = 1;
	// wait for a condition variable indicating the thread has exited to be signalled
	// delete the mutex and condition

	pthread_mutex_destroy(&lockmutex);

	initialised = 0;

	return jfauderr_noerror;
}


jfauderr thread_entercritical(void)
{
	if (!initialised) return jfauderr_notinited;
	if (pthread_mutex_lock(&lockmutex)) return jfauderr_genericerror;
	return jfauderr_noerror;
}

jfauderr thread_leavecritical(void)
{
	if (!initialised) return jfauderr_notinited;
	if (pthread_mutex_unlock(&lockmutex)) return jfauderr_genericerror;
	return jfauderr_noerror;
}
#endif

jfauderr thread_startrefresh(void)
{
	return jfauderr_noerror;
}


jfauderr thread_stoprefresh(void)
{
	return jfauderr_noerror;
}

